/**************************************************************
**
**         C SWING  v 3.1   31-JUL-1989 09:07:23.54
**         =========================================
**
**         Author    :  S.J.Brown
**
**         Copyright :  Public Domain
**
**         File      :  SWING.H
**
**         Language  :  VAXC
**
**         Compiler  :  VAX/VMS C v 2.4
**
**         VMS Ver.  :  5.1
**
***************************************************************
**
**         Change History
**         ==============
**
**         Date        Change                          Initials
**         ----------------------------------------------------
**         31-JUL-1989 Initial Version v3.0               SJB
**
**************************************************************/
 
/*
#define debug 		1
*/

/*
**  *** Beginning of Site Customizations ***
**
**  (Just move the #defines outside the comment lines to select that option.)
*/

/* define this to get the local (Rutgers) changes; you'll also need to compile
** and link with this as the command files as supplied do not use this option.
** Peter Chen 11/2/90
#define LOCALFIX 1
*/

/* If you like the way i like EXIT aq exit with return
** then define this. Mats 910506
#define MATS_HACK
*/

/* Define this if you want to use both [Return] or Q to return from File
** to Directory manager screen.  CB: 11-Jul-91
#define CR_RETURNS_FROM_FILE_TO_DIR_MGR
*/

/* Define this if you want the Q options to return to the original directory
** instead of the current one.  This restores the behavior of an older patch.
#define Q_EXITS_TO_ORIGINAL_DIR
*/

/* Define this if you want to seek and use a device__000000__SWSVE.DAT file
** if a device__directory__SWSVE.DAT file was not found.  Defining it sets
** the intended behavior of v3.6.2 (with some bug fixes).  The consequence
** of using a __000000__ file is that a tree for the *entire* device is
** displayed.  I personally do not recommend defining it, because on occasions
** when you really do want the entire device tree displayed it's easy enough
** to include 000000 in the directory field of the command line argument.
** Moreover, I've added a command line qualifier so that if you do not
** define it, you can evoke this behavior by entering a -0 or /0 argument
** in the call to CSWING.					FM: 11-Sep-92
#define ALWAYS_TRY_000000
*/

/* Define this if you want to make SYS$SYSROOT the default device when you
** exit in a SYS$SPECIFIC tree and such (a) tree(s) had been put up via an 
** argument or logical translation that had SYS$SYSROOT as the device.  Note
** that this behavior will apply for all SYS$SPECIFIC trees if any have been
** put up via a SYS$$SYSROOT argument or translation, but not if all were
** put up via SYS$SPECIFIC:[directory] arguments.  If you do not define it,
** you can evoke this behavior by entering a -s or /s argument in the call
** to CSWING.							FM: 11-Sep-92
#define SPECIFIC_EXITS_TO_SYSROOT
*/

/* Define this if you want to make SYS$SYSROOT the default device when you
** exit in a SYS$COMMON tree and such (a) tree(s) had been put up via an 
** argument or logical translation that had SYS$SYSROOT as the device.  Note
** that this behavior will apply for all SYS$COMMON trees if any have been
** put up via a SYS$$SYSROOT argument or translation, but not if all were
** put up via SYS$COMMON:[directory] arguments.  If you do not define it,
** you can evoke this behavior by entering a -c or /c argument in the call
** to CSWING.							FM: 11-Sep-92
#define COMMON_EXITS_TO_SYSROOT
*/

/*
**  *** End of Site Customizations ***
*/

#ifdef MATS_HACK
#define CR_RETURNS_FROM_FILE_TO_DIR_MGR
#endif

#ifdef VMS_V5
/*
**  version 5 VMS speed me ups
*/
#define malloc	VAXC$MALLOC_OPT
#define calloc  VAXC$CALLOC_OPT
#define free	VAXC$FREE_OPT
#define cfree	VAXC$CFREE_OPT
#define realloc	VAXC$REALLOC_OPT
#endif

#define VERSION	"C SWING v3.6.5 (S.J.Brown, M.Akerberg, H.Flowers, F.Macrides & others)"
#define DEFAULT_DIR_SPEC	"*.*"

#define AUTO_CONTINUAL_UPDATE	5

#define NO_TERMINATE_CHAR	'^'
#define NO_FILE_CHAR		'!'

#define CAPTIVE_ERRMSG		"Function disabled for captive accounts"

#define PRESS_TO_CONTINUE	"Press any key to continue..."
#define ESCAPE			27

#define LISTING_FILE		"SWING_LISTING_FILE"

#define SCROLL_WIDTH		75
#define MAX_FILES_SCROLL	14

#define WORLD_READ_WRITE	6

#define FM_TYPE_MAX		9

#define MOVE_FILES	1
#define COPY_FILES	2

#define SHOW_FILES		1
#define SHOW_DIRS		2
#define SHOW_FILES_AND_DIRS	3

#define PRINT_FILES	1
#define SUBMIT_FILES	2

#define INCLUDE_FILES	1
#define EXCLUDE_FILES	2

#define OL_FM_TYPE		0
#define OL_PRINT_QUEUE		1
#define OL_BATCH_QUEUE		2
#define OL_EDITOR_DEFN		3

#define FILE_MANAGER		0
#define USER_OPTIONS		1

#define AUTO_UPDATE_DELAY	5
#define MIN_BROADCAST_TIME	2
#define ALLOW_CLOCK		2
#define ALLOW_AUTO		1
#define NO_AUTO			0

#define CTRLY		0x02000000
#define CTRLT		0x00100000

#define IMPORT 100
#define EXPORT 101

#define DELETE 101
#define PURGE  202

#define SCREEN_WIDTH 	80
#define PAGE_MIN_LENGTH	24

#define NAME_SIZE       88
#define SPEC_SIZE 	255
#define MAX_LEVEL 	8
#define MAX_ADD_LEVEL   7
#define NAME_SHORT_SIZE 9
#define NAME_LONG_SIZE  15
#define BLANK_SHORT_NAME "         "

#define LEVEL_OFFSET(A) 	(A*(NAME_SHORT_SIZE+1))+1
#define C_DIAMOND	1
#define C_UP 		1
#define C_DOWN		2
#define C_LEFT		4
#define C_RIGHT		8

#define DISPLAY_DCL_ROWS	page_length
#define DISPLAY_DCL_COLUMNS	80

#define MESSAGE_ROWS		18
#define MESSAGE_COLS		78
#define MESSAGE_X		2
#define MESSAGE_Y		4

#define DISPLAY1_ROWS		(page_length-3)
#define DISPLAY1_COLUMNS	80
#define DISPLAY1_X              1
#define DISPLAY1_Y              3

#define DISPLAYF_ROWS		(page_length-5)
#define DISPLAYF_COLUMNS	78
/*
**  put the display over in the left
*/
#define DISPLAYF_X              2
#define DISPLAYF_Y              4

#define DISPLAYF_FILES		(DISPLAYF_ROWS-2)
#define CHOSEN_FILE_RENDITION	(SMG$M_REVERSE)
#define CURSOR_RENDITION 	(0)
#define FILE_PAGE_ROWS		(DISPLAYF_FILES-3)
#define LEFTF_COL		3
#define RIGHTF_COL              48

#define FILENAME_OFFSET		3
#define	CURSOR_SIZE		2

#define CURS_MIN		4
#define CURS_MAX                (DISPLAY1_ROWS-5)
#define MAX_B4_SCROLL		10
/* 
** for next-page and prev-page 
*/
#define PAGE_SIZE               DISPLAY1_ROWS

#define DISPLAYT_ROWS		2
#define DISPLAYT_COLUMNS	80
#define DISPLAYT_X              1
#define DISPLAYT_Y              1

#define STATUS_X		1
#define STATUS_Y		2

#define DISPLAYB_ROWS		1
#define DISPLAYB_COLUMNS	80
#define DISPLAYB_X              1
#define DISPLAYB_Y              page_length

#define CUR_REST_Y		1
#define CUR_REST_X		80

#define DELETE_SCREEN_ROWS	10
#define DELETE_SCREEN_COLUMNS	60

#define DELETE_MSG_Y		DELETE_SCREEN_ROWS
#define DELETE_MSG_X		2

#define DELETE_SCREEN_X		((SCREEN_WIDTH - DELETE_SCREEN_COLUMNS)/2 + 1)
#define DELETE_SCREEN_Y		7

#define DELETE_FILE_X		2
#define DELETE_FILE_Y		2

#define DELETE_STAT_X		2
#define DELETE_STAT_Y		4

#define DELETE_STAT1_X		2
#define DELETE_STAT1_Y		5

#define DELETE_STATUS_X		2
#define DELETE_STATUS_Y		7

#define DELETE_STATUS1_X	2
#define DELETE_STATUS1_Y	8

#define DELETE_STATUS2_X	2
#define DELETE_STATUS2_Y	9

#define _S(A)		&A[strlen(A)]

#define SPECIAL_RENDITION	(SMG$M_UNDERLINE|SMG$M_BOLD)
#define NORMAL_RENDITION	(SMG$M_REVERSE)
#define UNDERLINE_RENDITION	(SMG$M_REVERSE | SMG$M_UNDERLINE)
#define DELETING_RENDITION      (SMG$M_BLINK)

#define CTITLE "Create    Quit     [RETURN]     Top      Bottom      Next page     Previous page!"
#define MTITLE "Create    Rename    Delete    Move    pUrge    Quit   Help    Files   Locate   ?!"
#define DTITLE "Quit    ^D = user definable options    Help    ? = quick help screen     $ = DCL!"
#define FTITLE "Edit   eXecute   Copy   Rename   Delete    Move   pUrge   Quit   Help   List   ?!"
#define UTITLE "Change-value    Restore-original-value   Exit(& save changes)   Quit    Help   ?!"
#define STITLE "Alloc  Count  Dir-name  Files  Grand-total  Idx  List  Max  Quit  Stats  Used  ?!"

#define SAVE_FILE_SPEC		"SWSVE.DAT;1"
#define USER_OPTIONS_FILE	"SWING_OPTIONS.INITIAL"

/*
**  for holding display line structures
*/
typedef struct n_node {
char dir_name[SPEC_SIZE+1];
char name[NAME_SIZE+1];
char short_name[NAME_SHORT_SIZE+1];
char last_filename[NAME_SIZE+1];
char dir_spec[NAME_SIZE+1];
short in_or_ex_clude;
/*
**  did of this directory
*/
short did[3];
/*
**  fid of this directory
*/
short fid[3];
struct n_node *child;
struct n_node *sister;
struct n_node *lost;
unsigned long checksum;
int line;
int level;
/*
**  statistics
*/
int stats_total_files;
int stats_total_size_alloc;
int stats_total_size_used;
int stats_biggest_file;
int stats_non_zero_files;
int stats_total_pointers;
int stats_collected;
} NODE;

/*
**  for holding a directory structure header
*/
typedef struct dstructure {
NODE *fnp;
char device[NAME_SIZE];
char save_file_away[SPEC_SIZE+1];
char save_file_home[SPEC_SIZE+1];
char save_file_ss[SPEC_SIZE+1];
char dir_name[SPEC_SIZE+1];
char name[NAME_SIZE+1];
struct dstructure *forw_ptr;
int to_be_saved;
} DSTRUCTURE;

/*
**  for holding single directory structures
*/
typedef struct l_line {
struct l_line *forw_ptr;
struct l_line *back_ptr;
struct n_node *n_ptr[MAX_LEVEL+1];
struct dstructure *dp;
char connections[MAX_LEVEL+1];
} LINE;


#define CREDATE_SIZE 8

/*
**  for holding a file structure - NOTE, when adding more elements to 
**  this structure, also update reasses_files, where selected elements
**  are copied from one structure to another
*/
typedef struct fl {
/*
**  links to other structures
*/
struct fl *forw_ptr;
struct f1 *back_ptr;

/*
**  filename
*/
char filename[NAME_SIZE+1];

/*
**  creation date
*/
unsigned char credate[CREDATE_SIZE+1];

unsigned char  file_org,	/* file organisation */
               rec_attr,	/* record attributes */
	       bkt,		/* bucket size */
               rec_type;	/* record type */

unsigned short did[3];		/* directory id */
unsigned short fid[3],		/* file id */
               placement,	/* placement information */
               grp,		/* group id */
               mbm,		/* member id */
               fpro,		/* file protection */
               defext,		/* default extension */
               gbc,		/* global buffer count */
               versions,	/* max number of versions for directory */
               verlim,	        /* max number of versions for file */
               rsize,		/* record size */
               maxrec;		/* maximum record size */

unsigned long  headers, 	/* file headers */
               fragments,	/* file fragments */
               size,		/* size */
               allocation,	/* allocation */
               uchar,		/* file characteristics */
               uic;		/* uic */

int info_lookup;		/* status from directory lookup */

int rendition;			/* current rendition */

} FILER;

typedef struct acb_struct {
        short atr$w_size;
        short atr$w_type;
        long  atr$l_addr;
} ACB;

typedef struct fatdef_struct {
        char fat$b_rtype;
        char fat$b_rattrib;
        unsigned short fat$w_rsize;
        unsigned short fat$w_hiblk[2];
        unsigned short fat$w_efblk[2];
        unsigned short fat$w_ffbyte;
        char fat$b_bktsize;
	char fat$b_vfcsize;
	unsigned short fat$w_maxrec;
	unsigned short fat$w_defext;
	unsigned short fat$w_gbc;
        char _reserved[6];
        char _not_used[2];
	unsigned short fat$w_versions;
        unsigned long fat$l_sbn;
} FAT;

typedef struct user_opt_struct {
	int key;
	int no_terminate;
        char key_name[60];
        char value[SCREEN_WIDTH+1];
        char original[SCREEN_WIDTH+1];
        char *default_value;
} UOPT;
